import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, ViewEncapsulation, Input, Output, NgModule } from '@angular/core';
import { Guard } from '@authing/native-js-ui-components';

class GuardService {
    constructor() { }
}
GuardService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: GuardService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
GuardService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: GuardService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: GuardService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return []; } });

class GuardComponent {
    constructor() {
        this.onLoad = new EventEmitter();
        this.onLoadError = new EventEmitter();
        this.onLogin = new EventEmitter();
        this.onLoginError = new EventEmitter();
        this.onRegister = new EventEmitter();
        this.onRegisterError = new EventEmitter();
        this.onEmailSend = new EventEmitter();
        this.onEmailSendError = new EventEmitter();
        this.onPhoneSend = new EventEmitter();
        this.onPhoneSendError = new EventEmitter();
        this.onPwdReset = new EventEmitter();
        this.onPwdResetError = new EventEmitter();
        this.onClose = new EventEmitter();
        this.onLangChange = new EventEmitter();
    }
    ngAfterViewInit() {
        // @ts-ignore
        this.guard = new Guard({
            appId: this.appId,
            config: this.config,
            tenantId: this.tenantId,
            authClient: this.authClient,
        });
        this.guard.on('load', (...rest) => this.onLoad.emit(rest));
        this.guard.on('load-error', (...rest) => this.onLoadError.emit(rest));
        this.guard.on('login', (...rest) => this.onLogin.emit(rest));
        this.guard.on('login-error', (...rest) => this.onLoginError.emit(rest));
        this.guard.on('register', (...rest) => this.onRegister.emit(rest));
        this.guard.on('register-error', (...rest) => this.onRegisterError.emit(rest));
        this.guard.on('close', (...rest) => this.onClose.emit(rest));
        this.guard.on('lang-change', (...rest) => this.onLangChange.emit(rest));
        if (this.visible === true) {
            this.guard.show();
        }
    }
    ngOnInit() { }
    ngOnChanges() {
        if (this.visible !== undefined && this.guard) {
            if (this.visible) {
                this.guard?.show();
            }
            else {
                this.guard?.hide();
            }
        }
    }
}
GuardComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: GuardComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
GuardComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.3.0", type: GuardComponent, selector: "guard", inputs: { guard: "guard", appId: "appId", visible: "visible", tenantId: "tenantId", authClient: "authClient", config: "config" }, outputs: { onLoad: "onLoad", onLoadError: "onLoadError", onLogin: "onLogin", onLoginError: "onLoginError", onRegister: "onRegister", onRegisterError: "onRegisterError", onEmailSend: "onEmailSend", onEmailSendError: "onEmailSendError", onPhoneSend: "onPhoneSend", onPhoneSendError: "onPhoneSendError", onPwdReset: "onPwdReset", onPwdResetError: "onPwdResetError", onClose: "onClose", onLangChange: "onLangChange" }, usesOnChanges: true, ngImport: i0, template: `<div id="guard_container"></div>`, isInline: true, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: GuardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'guard', template: `<div id="guard_container"></div>`, encapsulation: ViewEncapsulation.None }]
        }], ctorParameters: function () { return []; }, propDecorators: { guard: [{
                type: Input
            }], appId: [{
                type: Input
            }], visible: [{
                type: Input
            }], tenantId: [{
                type: Input
            }], authClient: [{
                type: Input
            }], config: [{
                type: Input
            }], onLoad: [{
                type: Output
            }], onLoadError: [{
                type: Output
            }], onLogin: [{
                type: Output
            }], onLoginError: [{
                type: Output
            }], onRegister: [{
                type: Output
            }], onRegisterError: [{
                type: Output
            }], onEmailSend: [{
                type: Output
            }], onEmailSendError: [{
                type: Output
            }], onPhoneSend: [{
                type: Output
            }], onPhoneSendError: [{
                type: Output
            }], onPwdReset: [{
                type: Output
            }], onPwdResetError: [{
                type: Output
            }], onClose: [{
                type: Output
            }], onLangChange: [{
                type: Output
            }] } });

class GuardModule {
    constructor() { }
}
GuardModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: GuardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
GuardModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.3.0", ngImport: i0, type: GuardModule, declarations: [GuardComponent], exports: [GuardComponent] });
GuardModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: GuardModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: GuardModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [GuardComponent],
                    imports: [],
                    exports: [GuardComponent],
                }]
        }], ctorParameters: function () { return []; } });

/*
 * Public API Surface of guard
 */

/**
 * Generated bundle index. Do not edit.
 */

export { GuardComponent, GuardModule, GuardService };
//# sourceMappingURL=authing-ng-ui-components.mjs.map
