import { OnInit, EventEmitter, OnChanges } from '@angular/core';
import { AuthenticationClient, Guard as NativeGuard, GuardLocalConfig } from '@authing/native-js-ui-components';
import * as i0 from "@angular/core";
export declare class GuardComponent implements OnInit, OnChanges {
    constructor();
    guard: NativeGuard;
    appId?: string;
    visible?: boolean;
    tenantId?: string;
    authClient?: AuthenticationClient;
    config?: Partial<GuardLocalConfig>;
    onLoad: EventEmitter<[authClient: AuthenticationClient]>;
    onLoadError: EventEmitter<[error: any]>;
    onLogin: EventEmitter<[user: import("@authing/native-js-ui-components").User, authClient: AuthenticationClient]>;
    onLoginError: EventEmitter<[errorMessages: any]>;
    onRegister: EventEmitter<[user: import("@authing/native-js-ui-components").User, authClient: AuthenticationClient]>;
    onRegisterError: EventEmitter<[error: any]>;
    onEmailSend: EventEmitter<[authClient: AuthenticationClient, sence?: import("@authing/native-js-ui-components").EmailScene | undefined]>;
    onEmailSendError: EventEmitter<[error?: import("@authing/native-js-ui-components").CommonMessage | undefined, authClient?: AuthenticationClient | undefined, sence?: import("@authing/native-js-ui-components").EmailScene | undefined]>;
    onPhoneSend: EventEmitter<[authClient: AuthenticationClient, sence?: import("@authing/native-js-ui-components").SceneType | undefined]>;
    onPhoneSendError: EventEmitter<[error: import("@authing/native-js-ui-components").CommonMessage, authClient: AuthenticationClient, sence?: import("@authing/native-js-ui-components").SceneType | undefined]>;
    onPwdReset: EventEmitter<[authClient: AuthenticationClient]>;
    onPwdResetError: EventEmitter<[error: import("@authing/native-js-ui-components").CommonMessage, authClient: AuthenticationClient]>;
    onClose: EventEmitter<[]>;
    onLangChange: EventEmitter<[lang: import("@authing/native-js-ui-components").Lang]>;
    ngAfterViewInit(): void;
    ngOnInit(): void;
    ngOnChanges(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<GuardComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<GuardComponent, "guard", never, { "guard": "guard"; "appId": "appId"; "visible": "visible"; "tenantId": "tenantId"; "authClient": "authClient"; "config": "config"; }, { "onLoad": "onLoad"; "onLoadError": "onLoadError"; "onLogin": "onLogin"; "onLoginError": "onLoginError"; "onRegister": "onRegister"; "onRegisterError": "onRegisterError"; "onEmailSend": "onEmailSend"; "onEmailSendError": "onEmailSendError"; "onPhoneSend": "onPhoneSend"; "onPhoneSendError": "onPhoneSendError"; "onPwdReset": "onPwdReset"; "onPwdResetError": "onPwdResetError"; "onClose": "onClose"; "onLangChange": "onLangChange"; }, never, never, false>;
}
